## Preparation

- [ ] [Review if there are unreleased commits](<link TBD>) to be patched for each version. If not, adjust the steps to account for the required versions.

Stable branches for projects under the [GitLab Managed Versioning] model are required to have a green pipeline to perform a patch release.
- [ ] Verify pipelines on stable branches on GitLab are green:
<% versions.each do |version| -%>
  - [ ] [<%= version.stable_branch(ee: true) %>](https://gitlab.com/gitlab-org/gitlab/commits/<%= version.stable_branch(ee: true) %>)
<% end %>
- [ ] Verify pipelines on the GitLab projects are green:
<% projects.each do |project| -%>
* **<%= project.metadata_project_name %>**
  <% versions.each do |version| -%>
  - [ ] [<%= version.stable_branch %>](https://gitlab.com/<%= project.path %>/commits/<%= version.stable_branch %>)
  <% end %>
<% end %>

If a failure is found the resolution process differs between each project:
* For GitLab failures, follow the broken stable branch process: <link_tbd>
* For GitLab components, contact the maintainers and notify them about the failure.

- [ ] Ensure that any post-deploy migrations in the stable branch have been executed on GitLab.com by [executing the post-deploy migration pipeline]:
  `/chatops run post_deploy_migrations execute`.

## Packaging

- [ ] Check if mirroring synced stable branches to dev. If the output is :white_check_mark: for every repo, we can proceed to tag.
      Note. If GitLab Canonical to Security mirroring has diverged on the default branch due to security merges this mirror is expected to show as a broken and can be safely ignored.

   ```
   /chatops run mirror status
   ```
<% versions.each do |version| -%>
- [ ] Tag `<%= version %>` and wait for the job to finish before tagging the next package:
   ```sh
   /chatops run release tag <%= version %>
   ```
<% end %>

- [ ] While waiting for packages to build, [review and complete the blog post]. => BLOG_POST_MR
  - If the blog post failed to generate, it can be generated manually from the release-tools project with `rake release:patch_release_blog_post`.
- [ ] Check the progress of the EE/CE packages:
<% versions.each do |version| -%>
  - [ ] EE: [<%= version.to_omnibus(ee: true) %>](https://dev.gitlab.org/gitlab/omnibus-gitlab/commits/<%= version.to_omnibus(ee: true) %>)
  - [ ] CE: [<%= version.to_omnibus(ee: false) %>](https://dev.gitlab.org/gitlab/omnibus-gitlab/commits/<%= version.to_omnibus(ee: false) %>)
<% end %>

Note this  may take a while (around 80 minutes) and only the EE packages are required to continue with the next steps.

## Deploy

For patch releases, the only available environment for deploys is `release.gitlab.net`. All GitLab Inc. team members can login to that installation using their email address (through google oauth). Deployment to release.gitlab.net will only be performed for the current release version.

### release.gitlab.net

Deployments to release.gitlab.net are performed automatically.

<details>
  <summary>Instructions to manually deploy if required.</summary>

If you need to manually run a deployment, you can do so as follows:

```sh
/chatops run deploy 15.6.3-ee.0 release
```

</details>

## Release

<% versions.each do |version| %>
  **<%= version %>**
  - [ ] Publish the packages via ChatOps:
     ```
     /chatops run publish <%= version %>
     ```
  - [ ] Verify that the chatops `publish` pipeline created by running the above command succeeded.
  - [ ] Verify the `check-packages` job completes successfully on the [EE Pipeline](https://dev.gitlab.org/gitlab/omnibus-gitlab/commits/<%= version.to_omnibus(ee: true) %>)
  - [ ] Verify the `check-packages` job completes successfully on the [CE Pipeline](https://dev.gitlab.org/gitlab/omnibus-gitlab/commits/<%= version.to_omnibus(ee: false) %>)
  - [ ] Verify that Docker images appear on `hub.docker.com`: [EE](https://hub.docker.com/r/gitlab/gitlab-ee/tags) / [CE](https://hub.docker.com/r/gitlab/gitlab-ce/tags)
<% end %>

## Final steps

- [ ] Merge the blog post.
- [ ] Notify the patch release has been published (`blog post link` needs to be replaced with the actual link).
   ```
   /chatops run notify ":mega: GitLab Patch Release: <%= versions_title %> has just been released: <blog post link>! Share this release blog post with your network to ensure broader visibility across our community."
   ```
<% versions.each do |version| -%>
- [ ] Create the `<%= version %>` version on [version.gitlab.com](https://version.gitlab.com/versions/new?version=<%= version %>).
<% end %>

## Release Certification

The [release certification process](https://about.gitlab.com/handbook/ceo/chief-of-staff-team/jihu-support/release-certification.html) may apply to this release. cc @gitlab-com/gl-security/federal-application-security

[review and complete the blog post]: https://gitlab.com/gitlab-org/release/docs/blob/master/general/patch/blog-post.md
[executing the post-deploy migration pipeline]: https://gitlab.com/gitlab-org/release/docs/-/tree/master/general/post_deploy_migration#how-to-execute-post-deploy-migrations

/due in 7 days
